<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>mi_fifo Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>mi_fifo Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions&gt;<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id276788">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id270032">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249365">1.2. FIFO command syntax</a></span></dt><dt><span class="section"><a href="#id248003">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248009">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249567">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249592">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249598">1.4.1. <code class="varname">fifo_name</code> (string)</a></span></dt><dt><span class="section"><a href="#id249636">1.4.2. <code class="varname">fifo_mode</code> (integer)</a></span></dt><dt><span class="section"><a href="#id249672">1.4.3. <code class="varname">fifo_group</code> (integer)
		<code class="varname">fifo_group</code> (string)</a></span></dt><dt><span class="section"><a href="#id293400">1.4.4. <code class="varname">fifo_user</code> (integer)
		<code class="varname">fifo_group</code> (string)</a></span></dt><dt><span class="section"><a href="#id293436">1.4.5. <code class="varname">reply_dir</code> (string)</a></span></dt><dt><span class="section"><a href="#id293472">1.4.6. <code class="varname">reply_indent</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293510">1.5. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293520">1.6. Example</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249615">Set <code class="varname">fifo_name</code> parameter</a></dt><dt>1.2. <a href="#id249655">Set <code class="varname">fifo_mode</code> parameter</a></dt><dt>1.3. <a href="#id249693">Set <code class="varname">fifo_group</code> parameter</a></dt><dt>1.4. <a href="#id293420">Set <code class="varname">fifo_user</code> parameter</a></dt><dt>1.5. <a href="#id293456">Set <code class="varname">reply_dir</code> parameter</a></dt><dt>1.6. <a href="#id293494">Set <code class="varname">reply_indent</code> parameter</a></dt><dt>1.7. <a href="#id293532">FIFO request</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id276788"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id270032"></a>1.1. Overview</h2></div></div></div><p>
		This is a module which provides a FIFO transport layer 
		implementation for Management Interface.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249365"></a>1.2. FIFO command syntax</h2></div></div></div><p>
		The external commands issued via FIFO interface must follow the
		following syntax:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>
			request = first_line argument*
			</em></span></p></li><li><p><span class="emphasis"><em>
			first_line = ':'command_name':'reply_fifo'\n'
			</em></span></p></li><li><p><span class="emphasis"><em>
			argument = (arg_name '::' (arg_value)? ) | (arg_value)
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_name = not-quoted_string
			</em></span></p></li><li><p><span class="emphasis"><em>
			arg_value = not-quoted_string | '"' string '"'
			</em></span></p></li><li><p><span class="emphasis"><em>
			not-quoted_string = string - {',",\n,\r}
			</em></span></p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248003"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248009"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249567"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249592"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249598"></a>1.4.1. <code class="varname">fifo_name</code> (string)</h3></div></div></div><p>
		The name of the FIFO file to be created for listening and 
		reading external commands.
		</p><p>
		<span class="emphasis"><em>
			Default value is NONE.
		</em></span>
		</p><div class="example"><a name="id249615"></a><p class="title"><b>Example 1.1. Set <code class="varname">fifo_name</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_fifo", "fifo_name", "/tmp/opensips_fifo")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249636"></a>1.4.2. <code class="varname">fifo_mode</code> (integer)</h3></div></div></div><p>
		Permission to be used for creating the listening FIFO file. It 
		follows the UNIX conventions.
		</p><p>
		<span class="emphasis"><em>
			Default value is 0660 (rw-rw----).
		</em></span>
		</p><div class="example"><a name="id249655"></a><p class="title"><b>Example 1.2. Set <code class="varname">fifo_mode</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_fifo", "fifo_mode", 0600)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249672"></a>1.4.3. <code class="varname">fifo_group</code> (integer)
		<code class="varname">fifo_group</code> (string)</h3></div></div></div><p>
		Group to be used for creating the listening FIFO file.
		</p><p>
		<span class="emphasis"><em>
			Default value is the inherited one.
		</em></span>
		</p><div class="example"><a name="id249693"></a><p class="title"><b>Example 1.3. Set <code class="varname">fifo_group</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_fifo", "fifo_group", 0)
modparam("mi_fifo", "fifo_group", "root")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293400"></a>1.4.4. <code class="varname">fifo_user</code> (integer)
		<code class="varname">fifo_group</code> (string)</h3></div></div></div><p>
		User to be used for creating the listening FIFO file.
		</p><p>
		<span class="emphasis"><em>
			Default value is the inherited one.
		</em></span>
		</p><div class="example"><a name="id293420"></a><p class="title"><b>Example 1.4. Set <code class="varname">fifo_user</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_fifo", "fifo_user", 0)
modparam("mi_fifo", "fifo_user", "root")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293436"></a>1.4.5. <code class="varname">reply_dir</code> (string)</h3></div></div></div><p>
		Directory to be used for creating the reply FIFO files.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">/tmp/</span>&#8221;
		</em></span>
		</p><div class="example"><a name="id293456"></a><p class="title"><b>Example 1.5. Set <code class="varname">reply_dir</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_fifo", "reply_dir", "/home/opensips/tmp/")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293472"></a>1.4.6. <code class="varname">reply_indent</code> (string)</h3></div></div></div><p>
		Strings to be used for line indentation. As the MI data structure 
		is tree oriendeted, the depth level will printed as indentation.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">"\t" (TAB)</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293494"></a><p class="title"><b>Example 1.6. Set <code class="varname">reply_indent</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_fifo", "reply_indent", "    ")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293510"></a>1.5. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293520"></a>1.6. Example</h2></div></div></div><p>
		This is an example showing the FIFO format for the 
		&#8220;<span class="quote">get_statistics dialog: tm:</span>&#8221; MI commad:
		response.
		</p><div class="example"><a name="id293532"></a><p class="title"><b>Example 1.7. FIFO request</b></p><div class="example-contents"><pre class="programlisting">

:get_statistics:reply_fifo\n
dialog:\n
tm:\n
\n

</pre></div></div><br class="example-break"></div></div></div></body></html>
