<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>mmgeoip Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>mmgeoip Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Kobi</span> <span class="surname">Eshun</span></h3><div class="affiliation"><span class="orgname">SightSpeed, Inc.<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Kobi</span> <span class="surname">Eshun</span></h3></div></div></div><div><p class="copyright">Copyright © 2008 SightSpeed, Inc.</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id284079">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284083">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249059">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249064">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248015">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249578">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249584">1.3.1. <code class="varname">mmgeoip_city_db_path</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249620">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249626">1.4.1. 
		<code class="function">mmg_lookup([fields,]src,dst)</code>
	  </a></span></dt></dl></dd><dt><span class="section"><a href="#id293475">1.5. Known Issues</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249602">Set &#8220;<span class="quote">mmgeoip_city_db_path</span>&#8221; parameter</a></dt><dt>1.2. <a href="#id293456"><code class="function">mmg_lookup</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id284079"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284083"></a>1.1. Overview</h2></div></div></div><p>
	  This module is a lightweight wrapper for the MaxMind GeoIP
	  API. It adds IP address-to-location lookup capability to
	  OpenSIPS scripts.
	</p><p>
	  Lookups are executed against the freely-available GeoLite City
	  database; and the non-free GeoIP City database is drop-in
	  compatible. All lookup fields provided by the API are accessible
	  by the script. Visit the
	  <a class="ulink" href="http://www.maxmind.com/app/geolitecity" target="_top"><em class="citetitle">MaxMind
	  website</em></a> for more information on the location 
	  databases.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249059"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249064"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following  modules must be loaded before this module:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			  <span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
	  </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248015"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			  <span class="emphasis"><em>libGeoIP</em></span>.
			</p></li></ul></div><p>
	  </p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249578"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249584"></a>1.3.1. <code class="varname">mmgeoip_city_db_path</code> (string)</h3></div></div></div><p>
		Path to either a GeoLite or GeoIP City database file.
	  </p><p>
		<span class="emphasis"><em>
		  Mandatory parameter.
		</em></span>
	  </p><div class="example"><a name="id249602"></a><p class="title"><b>Example 1.1. Set &#8220;<span class="quote">mmgeoip_city_db_path</span>&#8221; parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mmgeoip", "mmgeoip_city_db_path",
  "/usr/share/GeoIP/GeoLiteCity.dat")
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249620"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249626"></a>1.4.1. 
		<code class="function">mmg_lookup([fields,]src,dst)</code>
	  </h3></div></div></div><p>
		Looks up specified <code class="varname">field</code>s associated with IP address
		specified by the <code class="varname">src</code>. The resulting data are
		loaded in <span class="emphasis"><em>reverse</em></span> order into
		the <code class="varname">dst</code> AVP.
	  </p><p>
		<code class="varname">src</code> can be a pseudo-variable or AVP;
		and <code class="varname">dst</code> <span class="emphasis"><em>must</em></span> be an AVP.
		<code class="varname">fields</code> defaults to "lon:lat," and is a
		colon-delimited list of these elements:
	  </p><div class="itemizedlist"><ul type="disc"><li><p> <code class="varname">lat</code> Latitude</p></li><li><p> <code class="varname">lon</code> Longitude</p></li><li><p> <code class="varname">cont</code> Continent</p></li><li><p> <code class="varname">cc</code> Country Code</p></li><li><p> <code class="varname">reg</code> Region</p></li><li><p> <code class="varname">city</code> City</p></li><li><p> <code class="varname">pc</code> Postal Code</p></li><li><p> <code class="varname">dma</code> DMA Code</p></li><li><p> <code class="varname">ac</code> Area Code</p></li><li><p> <code class="varname">TZ</code> Time Zone</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		ONREPLY_ROUTE, BRANCH_ROUTE,ERROR_ROUTE, and LOCAL_ROUTE.
	  </p><div class="example"><a name="id293456"></a><p class="title"><b>Example 1.2. <code class="function">mmg_lookup</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if(mmg_lookup("lon:lat","$si","$avp(lat_lon)")) {
  xlog("L_INFO","Source IP latitude:$(avp(lat_lon)[0])\n");
  xlog("L_INFO","Source IP longitude:$(avp(lat_lon)[1])\n");
};
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293475"></a>1.5. Known Issues</h2></div></div></div><p>
	  It is not currently possible to load an updated location
	  database without first stalling the server.
	</p></div></div></div></body></html>
